Loading...
Searching...
No Matches
pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar > Class Template Reference
Module registration

KFPCSInitialAlignment computes corresponding four point congruent sets based on keypoints as described in: "Markerless point cloud registration with keypoint-based 4-points congruent sets", Pascal Theiler, Jan Dirk Wegner, Konrad Schindler. More...

`#include <pcl/registration/ia_kfpcs.h>`

Inheritance diagram for pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >:

## Public Member Functions

| KFPCSInitialAlignment ()
| Constructor.
| ~KFPCSInitialAlignment () override=default
| Destructor.
void | setUpperTranslationThreshold (float upper_trl_boundary)
| Set the upper translation threshold used for score evaluation.
float | getUpperTranslationThreshold () const
void | setLowerTranslationThreshold (float lower_trl_boundary)
| Set the lower translation threshold used for score evaluation.
float | getLowerTranslationThreshold () const
void | setLambda (float lambda)
| Set the weighting factor of the translation cost term.
float | getLambda () const
void | getNBestCandidates (int n, float min_angle3d, float min_translation3d, MatchingCandidates &candidates)
| Get the N best unique candidate matches according to their fitness score.
void | getTBestCandidates (float t, float min_angle3d, float min_translation3d, MatchingCandidates &candidates)
| Get all unique candidate matches with fitness scores above a threshold t.
Public Member Functions inherited from pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >
| FPCSInitialAlignment ()
| Constructor.
| ~FPCSInitialAlignment () override=default
| Destructor.
void | setTargetIndices (const IndicesPtr &target_indices)
| Provide a pointer to the vector of target indices.
IndicesPtr | getTargetIndices () const
void | setSourceNormals (const NormalsConstPtr &source_normals)
| Provide a pointer to the normals of the source point cloud.
NormalsConstPtr | getSourceNormals () const
void | setTargetNormals (const NormalsConstPtr &target_normals)
| Provide a pointer to the normals of the target point cloud.
NormalsConstPtr | getTargetNormals () const
void | setNumberOfThreads (int nr_threads)
| Set the number of used threads if OpenMP is activated.
int | getNumberOfThreads () const
void | setDelta (float delta, bool normalize=false)
| Set the constant factor delta which weights the internally calculated parameters.
float | getDelta () const
void | setApproxOverlap (float approx_overlap)
| Set the approximate overlap between source and target.
float | getApproxOverlap () const
void | setScoreThreshold (float score_threshold)
| Set the scoring threshold used for early finishing the method.
float | getScoreThreshold () const
void | setNumberOfSamples (int nr_samples)
| Set the number of source samples to use during alignment.
int | getNumberOfSamples () const
void | setMaxNormalDifference (float max_norm_diff)
| Set the maximum normal difference between valid point correspondences in degree.
float | getMaxNormalDifference () const
void | setMaxComputationTime (int max_runtime)
| Set the maximum computation time in seconds.
int | getMaxComputationTime () const
float | getFitnessScore () const
Public Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
| Registration ()
| Empty constructor.
| ~Registration () override=default
| destructor.
void | setTransformationEstimation (const TransformationEstimationPtr &te)
| Provide a pointer to the transformation estimation object.
void | setCorrespondenceEstimation (const CorrespondenceEstimationPtr &ce)
| Provide a pointer to the correspondence estimation object.
virtual void | setInputSource (const PointCloudSourceConstPtr &cloud)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target)
PointCloudSourceConstPtr const | getInputSource ()
| Get a pointer to the input point cloud dataset target.
virtual void | setInputTarget (const PointCloudTargetConstPtr &cloud)
| Provide a pointer to the input target (e.g., the point cloud that we want to align the input source to)
PointCloudTargetConstPtr const | getInputTarget ()
| Get a pointer to the input point cloud dataset target.
void | setSearchMethodTarget (const KdTreePtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the target cloud.
KdTreePtr | getSearchMethodTarget () const
| Get a pointer to the search method used to find correspondences in the target cloud.
void | setSearchMethodSource (const KdTreeReciprocalPtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the source cloud (usually used by reciprocal correspondence finding).
KdTreeReciprocalPtr | getSearchMethodSource () const
| Get a pointer to the search method used to find correspondences in the source cloud.
Matrix4 | getFinalTransformation ()
| Get the final transformation matrix estimated by the registration method.
Matrix4 | getLastIncrementalTransformation ()
| Get the last incremental transformation matrix estimated by the registration method.
void | setMaximumIterations (int nr_iterations)
| Set the maximum number of iterations the internal optimization should run for.
int | getMaximumIterations ()
| Get the maximum number of iterations the internal optimization should run for, as set by the user.
void | setRANSACIterations (int ransac_iterations)
| Set the number of iterations RANSAC should run for.
double | getRANSACIterations ()
| Get the number of iterations RANSAC should run for, as set by the user.
void | setRANSACOutlierRejectionThreshold (double inlier_threshold)
| Set the inlier distance threshold for the internal RANSAC outlier rejection loop.
double | getRANSACOutlierRejectionThreshold ()
| Get the inlier distance threshold for the internal outlier rejection loop as set by the user.
void | setMaxCorrespondenceDistance (double distance_threshold)
| Set the maximum distance threshold between two correspondent points in source <-> target.
double | getMaxCorrespondenceDistance ()
| Get the maximum distance threshold between two correspondent points in source <-> target.
void | setTransformationEpsilon (double epsilon)
| Set the transformation epsilon (maximum allowable translation squared difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution.
double | getTransformationEpsilon ()
| Get the transformation epsilon (maximum allowable translation squared difference between two consecutive transformations) as set by the user.
void | setTransformationRotationEpsilon (double epsilon)
| Set the transformation rotation epsilon (maximum allowable rotation difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution.
double | getTransformationRotationEpsilon ()
| Get the transformation rotation epsilon (maximum allowable difference between two consecutive transformations) as set by the user (epsilon is the cos(angle) in a axis-angle representation).
void | setEuclideanFitnessEpsilon (double epsilon)
| Set the maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged.
double | getEuclideanFitnessEpsilon ()
| Get the maximum allowed distance error before the algorithm will be considered to have converged, as set by the user.
void | setPointRepresentation (const PointRepresentationConstPtr &point_representation)
| Provide a boost shared pointer to the PointRepresentation to be used when comparing points.
bool | registerVisualizationCallback (std::function< UpdateVisualizerCallbackSignature > &visualizerCallback)
| Register the user callback function which will be called from registration thread in order to update point cloud obtained after each iteration.
double | getFitnessScore (double max_range=std::numeric_limits< double >::max())
| Obtain the Euclidean fitness score (e.g., mean of squared distances from the source to the target)
double | getFitnessScore (const std::vector< float > &distances_a, const std::vector< float > &distances_b)
| Obtain the Euclidean fitness score (e.g., mean of squared distances from the source to the target) from two sets of correspondence distances (distances between source and target points)
bool | hasConverged () const
| Return the state of convergence after the last align run.
void | align (PointCloudSource &output)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output.
void | align (PointCloudSource &output, const Matrix4 &guess)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output.
const std::string & | getClassName () const
| Abstract class get name method.
bool | initCompute ()
| Internal computation initialization.
bool | initComputeReciprocal ()
| Internal computation when reciprocal lookup is needed.
void | addCorrespondenceRejector (const CorrespondenceRejectorPtr &rejector)
| Add a new correspondence rejector to the list.
std::vector< CorrespondenceRejectorPtr > | getCorrespondenceRejectors ()
| Get the list of correspondence rejectors.
bool | removeCorrespondenceRejector (unsigned int i)
| Remove the i-th correspondence rejector in the list.
void | clearCorrespondenceRejectors ()
| Clear the list of correspondence rejectors.
Public Member Functions inherited from pcl::PCLBase< PointSource >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointSource & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

bool | initCompute () override
| Internal computation initialization.
void | handleMatches (const pcl::Indices &base_indices, std::vector< pcl::Indices > &matches, MatchingCandidates &candidates) override
| Method to handle current candidate matches.
int | validateTransformation (Eigen::Matrix4f &transformation, float &fitness_score) override
| Validate the transformation by calculating the score value after transforming the input source cloud.
void | finalCompute (const std::vector< MatchingCandidates > &candidates) override
| Final computation of best match out of vector of matches.
Protected Member Functions inherited from pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >
void | computeTransformation (PointCloudSource &output, const Eigen::Matrix4f &guess) override
| Rigid transformation computation method.
int | selectBase (pcl::Indices &base_indices, float(&ratio)[2])
| Select an approximately coplanar set of four points from the source cloud.
int | selectBaseTriangle (pcl::Indices &base_indices)
| Select randomly a triplet of points with large point-to-point distances.
void | setupBase (pcl::Indices &base_indices, float(&ratio)[2])
| Setup the base (four coplanar points) by ordering the points and computing intersection ratios and segment to segment distances of base diagonal.
float | segmentToSegmentDist (const pcl::Indices &base_indices, float(&ratio)[2])
| Calculate intersection ratios and segment to segment distances of base diagonals.
virtual int | bruteForceCorrespondences (int idx1, int idx2, pcl::Correspondences &pairs)
| Search for corresponding point pairs given the distance between two base points.
virtual int | determineBaseMatches (const pcl::Indices &base_indices, std::vector< pcl::Indices > &matches, const pcl::Correspondences &pairs_a, const pcl::Correspondences &pairs_b, const float(&ratio)[2])
| Determine base matches by combining the point pair candidate and search for coinciding intersection points using the diagonal segment ratios of base B.
int | checkBaseMatch (const pcl::Indices &match_indices, const float(&ds)[4])
| Check if outer rectangle distance of matched points fit with the base rectangle.
virtual void | linkMatchWithBase (const pcl::Indices &base_indices, pcl::Indices &match_indices, pcl::Correspondences &correspondences)
| Sets the correspondences between the base B and the match M by using the distance of each point to the centroid of the rectangle.
virtual int | validateMatch (const pcl::Indices &base_indices, const pcl::Indices &match_indices, const pcl::Correspondences &correspondences, Eigen::Matrix4f &transformation)
| Validate the matching by computing the transformation between the source and target based on the four matched points and by comparing the mean square error (MSE) to a threshold.
Protected Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
bool | searchForNeighbors (const PointCloudSource &cloud, int index, pcl::Indices &indices, std::vector< float > &distances)
| Search for the closest nearest neighbor of a given point.
virtual void | computeTransformation (PointCloudSource &output, const Matrix4 &guess)=0
| Abstract transformation computation method with initial guess.
Protected Member Functions inherited from pcl::PCLBase< PointSource >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

float | lower_trl_boundary_ {-1.f}
| Lower boundary for translation costs calculation.
float | upper_trl_boundary_ {-1.f}
| Upper boundary for translation costs calculation.
float | lambda_ {0.5f}
| Weighting factor for translation costs (standard = 0.5).
MatchingCandidates | candidates_
| Container for resulting vector of registration candidates.
bool | use_trl_score_ {false}
| Flag if translation score should be used in validation (internal calculation).
pcl::IndicesPtr | indices_validation_
| Subset of input indices on which we evaluate candidates.
Protected Attributes inherited from pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >
NormalsConstPtr | source_normals_
| Normals of source point cloud.
NormalsConstPtr | target_normals_
| Normals of target point cloud.
int | nr_threads_ {1}
| Number of threads for parallelization (standard = 1).
float | approx_overlap_ {0.5f}
| Estimated overlap between source and target (standard = 0.5).
float | delta_ {1.f}
| Delta value of 4pcs algorithm (standard = 1.0).
float | score_threshold_
| Score threshold to stop calculation with success.
int | nr_samples_ {0}
| The number of points to uniformly sample the source point cloud.
float | max_norm_diff_ {90.f}
| Maximum normal difference of corresponding point pairs in degrees (standard = 90).
int | max_runtime_ {0}
| Maximum allowed computation time in seconds (standard = 0 => ~unlimited).
float | fitness_score_
| Resulting fitness score of the best match.
float | diameter_ {0.0f}
| Estimated diameter of the target point cloud.
float | max_base_diameter_sqr_ {0.0f}
| Estimated squared metric overlap between source and target.
bool | use_normals_ {false}
| Use normals flag.
bool | normalize_delta_ {true}
| Normalize delta flag.
pcl::IndicesPtr | source_indices_
| A pointer to the vector of source point indices to use after sampling.
pcl::IndicesPtr | target_indices_
| A pointer to the vector of target point indices to use after sampling.
float | max_pair_diff_ {0.0f}
| Maximal difference between corresponding point pairs in source and target.
float | max_edge_diff_ {0.0f}
| Maximal difference between the length of the base edges and valid match edges.
float | coincidation_limit_ {0.0f}
| Maximal distance between coinciding intersection points to find valid matches.
float | max_mse_ {0.0f}
| Maximal mean squared errors of a transformation calculated from a candidate match.
float | max_inlier_dist_sqr_ {0.0f}
| Maximal squared point distance between source and target points to count as inlier.
const float | small_error_ {0.00001f}
| Definition of a small error.
Protected Attributes inherited from pcl::Registration< PointSource, PointTarget, Scalar >
std::string | reg_name_
| The registration method name.
KdTreePtr | tree_
| A pointer to the spatial search object.
KdTreeReciprocalPtr | tree_reciprocal_
| A pointer to the spatial search object of the source.
int | nr_iterations_ {0}
| The number of iterations the internal optimization ran for (used internally).
int | max_iterations_ {10}
| The maximum number of iterations the internal optimization should run for.
int | ransac_iterations_ {0}
| The number of iterations RANSAC should run for.
PointCloudTargetConstPtr | target_
| The input point cloud dataset target.
Matrix4 | final_transformation_
| The final transformation matrix estimated by the registration method after N iterations.
Matrix4 | transformation_
| The transformation matrix estimated by the registration method.
Matrix4 | previous_transformation_
| The previous transformation matrix estimated by the registration method (used internally).
double | transformation_epsilon_ {0.0}
| The maximum difference between two consecutive transformations in order to consider convergence (user defined).
double | transformation_rotation_epsilon_ {0.0}
| The maximum rotation difference between two consecutive transformations in order to consider convergence (user defined).
double | euclidean_fitness_epsilon_
| The maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged.
double | corr_dist_threshold_
| The maximum distance threshold between two correspondent points in source <-> target.
double | inlier_threshold_ {0.05}
| The inlier distance threshold for the internal RANSAC outlier rejection loop.
bool | converged_ {false}
| Holds internal convergence state, given user parameters.
unsigned int | min_number_correspondences_ {3}
| The minimum number of correspondences that the algorithm needs before attempting to estimate the transformation.
CorrespondencesPtr | correspondences_
| The set of correspondences determined at this ICP step.
TransformationEstimationPtr | transformation_estimation_
| A TransformationEstimation object, used to calculate the 4x4 rigid transformation.
CorrespondenceEstimationPtr | correspondence_estimation_
| A CorrespondenceEstimation object, used to estimate correspondences between the source and the target cloud.
std::vector< CorrespondenceRejectorPtr > | correspondence_rejectors_
| The list of correspondence rejectors to use.
bool | target_cloud_updated_ {true}
| Variable that stores whether we have a new target cloud, meaning we need to pre-process it again.
bool | source_cloud_updated_ {true}
| Variable that stores whether we have a new source cloud, meaning we need to pre-process it again.
bool | force_no_recompute_ {false}
| A flag which, if set, means the tree operating on the target cloud will never be recomputed.
bool | force_no_recompute_reciprocal_ {false}
| A flag which, if set, means the tree operating on the source cloud will never be recomputed.
std::function< UpdateVisualizerCallbackSignature > | update_visualizer_
| Callback function to update intermediate source point cloud position during it's registration to the target point cloud.
Protected Attributes inherited from pcl::PCLBase< PointSource >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Additional Inherited Members

Public Types inherited from pcl::Registration< PointSource, PointTarget, Scalar >
using | Matrix4 = Eigen::Matrix< Scalar, 4, 4 >
using | Ptr = shared_ptr< Registration< PointSource, PointTarget, Scalar > >
using | ConstPtr = shared_ptr< const Registration< PointSource, PointTarget, Scalar > >
using | CorrespondenceRejectorPtr = pcl::registration::CorrespondenceRejector::Ptr
using | KdTree = pcl::search::KdTree< PointTarget >
using | KdTreePtr = typename KdTree::Ptr
using | KdTreeReciprocal = pcl::search::KdTree< PointSource >
using | KdTreeReciprocalPtr = typename KdTreeReciprocal::Ptr
using | PointCloudSource = pcl::PointCloud< PointSource >
using | PointCloudSourcePtr = typename PointCloudSource::Ptr
using | PointCloudSourceConstPtr = typename PointCloudSource::ConstPtr
using | PointCloudTarget = pcl::PointCloud< PointTarget >
using | PointCloudTargetPtr = typename PointCloudTarget::Ptr
using | PointCloudTargetConstPtr = typename PointCloudTarget::ConstPtr
using | PointRepresentationConstPtr = typename KdTree::PointRepresentationConstPtr
using | TransformationEstimation = typename pcl::registration::TransformationEstimation< PointSource, PointTarget, Scalar >
using | TransformationEstimationPtr = typename TransformationEstimation::Ptr
using | TransformationEstimationConstPtr = typename TransformationEstimation::ConstPtr
using | CorrespondenceEstimation = pcl::registration::CorrespondenceEstimationBase< PointSource, PointTarget, Scalar >
using | CorrespondenceEstimationPtr = typename CorrespondenceEstimation::Ptr
using | CorrespondenceEstimationConstPtr = typename CorrespondenceEstimation::ConstPtr
using | UpdateVisualizerCallbackSignature = void(const pcl::PointCloud< PointSource > &, const pcl::Indices &, const pcl::PointCloud< PointTarget > &, const pcl::Indices &)
| The callback signature to the function updating intermediate source point cloud position during it's registration to the target point cloud.
Public Types inherited from pcl::PCLBase< PointSource >
using | PointCloud = pcl::PointCloud< PointSource >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Detailed Description

template<typename PointSource, typename PointTarget, typename NormalT = pcl::Normal, typename Scalar = float>
class pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >

KFPCSInitialAlignment computes corresponding four point congruent sets based on keypoints as described in: "Markerless point cloud registration with keypoint-based 4-points congruent sets", Pascal Theiler, Jan Dirk Wegner, Konrad Schindler.

ISPRS Annals II-5/W2, 2013. Presented at ISPRS Workshop Laser Scanning, Antalya, Turkey, 2013.

Note
  Method has since been improved and some variations to the paper exist.

The main differences to FPCSInitialAlignment are:

1. KFPCSInitialAlignment stores all solution candidates instead of only the best one
2. KFPCSInitialAlignment uses an MSAC approach to score candidates instead of counting inliers

Author
  P.W.Theiler

Definition at line 64 of file ia_kfpcs.h.

## Constructor & Destructor Documentation

## KFPCSInitialAlignment()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::KFPCSInitialAlignment | ( |  | ) |

Constructor.

Definition at line 47 of file ia_kfpcs.hpp.

References pcl::Registration< PointSource, PointTarget, Scalar >::reg_name_.

## ~KFPCSInitialAlignment()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::~KFPCSInitialAlignment | ( |  | ) |

override default

Destructor.

## Member Function Documentation

## finalCompute()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

void pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::finalCompute | ( | const std::vector< MatchingCandidates > & | candidates | ) |

override protected virtual

Final computation of best match out of vector of matches.

To avoid cross thread dependencies during parallel running, a best match for each try was calculated.

Note
  For forwards compatibility the candidates are stored in vectors of 'vectors of size 1'.

Parameters

  [in] | candidates | vector of candidate matches

Reimplemented from pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >.

Definition at line 215 of file ia_kfpcs.hpp.

## getLambda()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getLambda | ( |  | ) | const

inline

Returns
  the weighting factor of the translation cost term.

Definition at line 134 of file ia_kfpcs.h.

References pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::lambda_.

## getLowerTranslationThreshold()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getLowerTranslationThreshold | ( |  | ) | const

inline

Returns
  the lower translation threshold used for score evaluation.

Definition at line 118 of file ia_kfpcs.h.

References pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::lower_trl_boundary_.

## getNBestCandidates()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

void pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getNBestCandidates | ( | int | n,
|  | float | min_angle3d,
|  | float | min_translation3d,
|  | MatchingCandidates & | candidates
| ) |  |

Get the N best unique candidate matches according to their fitness score.

The method only returns unique transformations comparing the translation and the 3D rotation to already returned transformations.

Note
  The method may return less than N candidates, if the number of unique candidates is smaller than N

Parameters

  [in] | n | number of best candidates to return
  [in] | min_angle3d | minimum 3D angle difference in radian
  [in] | min_translation3d | minimum 3D translation difference
  [out] | candidates | vector of unique candidates

Definition at line 257 of file ia_kfpcs.hpp.

## getTBestCandidates()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

void pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getTBestCandidates | ( | float | t,
|  | float | min_angle3d,
|  | float | min_translation3d,
|  | MatchingCandidates & | candidates
| ) |  |

Get all unique candidate matches with fitness scores above a threshold t.

The method only returns unique transformations comparing the translation and the 3D rotation to already returned transformations.

Parameters

  [in] | t | fitness score threshold
  [in] | min_angle3d | minimum 3D angle difference in radian
  [in] | min_translation3d | minimum 3D translation difference
  [out] | candidates | vector of unique candidates

Definition at line 294 of file ia_kfpcs.hpp.

## getUpperTranslationThreshold()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getUpperTranslationThreshold | ( |  | ) | const

inline

Returns
  the upper translation threshold used for score evaluation.

Definition at line 102 of file ia_kfpcs.h.

References pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::upper_trl_boundary_.

## handleMatches()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

void pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::handleMatches | ( | const pcl::Indices & | base_indices,
|  | std::vector< pcl::Indices > & | matches,
|  | MatchingCandidates & | candidates
| ) |  |

override protected virtual

Method to handle current candidate matches.

Here we validate and evaluate the matches w.r.t the base and store the sorted matches (together with score values and estimated transformations).

Parameters

  [in] | base_indices | indices of base B
  [in,out] | matches | vector of candidate matches w.r.t the base B. The candidate matches are reordered during this step.
  [out] | candidates | vector which contains the candidates matches M

Reimplemented from pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >.

Definition at line 118 of file ia_kfpcs.hpp.

## initCompute()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

bool pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::initCompute | ( |  | ) |

override protected virtual

Internal computation initialization.

Reimplemented from pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >.

Definition at line 56 of file ia_kfpcs.hpp.

References pcl::FilterIndices< PointT >::filter(), pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::initCompute(), pcl::PCLBase< PointT >::setIndices(), pcl::PCLBase< PointT >::setInputCloud(), and pcl::RandomSample< PointT >::setSample().

## setLambda()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setLambda | ( | float | lambda | ) |

inline

Set the weighting factor of the translation cost term.

Parameters

  [in] | lambda | the weighting factor of the translation cost term

Definition at line 127 of file ia_kfpcs.h.

References pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::lambda_.

## setLowerTranslationThreshold()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setLowerTranslationThreshold | ( | float | lower_trl_boundary | ) |

inline

Set the lower translation threshold used for score evaluation.

Parameters

  [in] | lower_trl_boundary | lower translation threshold

Definition at line 111 of file ia_kfpcs.h.

References pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::lower_trl_boundary_.

## setUpperTranslationThreshold()

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

void pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setUpperTranslationThreshold | ( | float | upper_trl_boundary | ) |

inline

Set the upper translation threshold used for score evaluation.

Parameters

  [in] | upper_trl_boundary | upper translation threshold

Definition at line 95 of file ia_kfpcs.h.

References pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::upper_trl_boundary_.

## validateTransformation()

template<typename PointSource , typename PointTarget , typename NormalT , typename Scalar >

int pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::validateTransformation | ( | Eigen::Matrix4f & | transformation,
|  | float & | fitness_score
| ) |  |

override protected virtual

Validate the transformation by calculating the score value after transforming the input source cloud.

The resulting score is later used as the decision criteria of the best fitting match.

Parameters

  [out] | transformation | updated orientation matrix using all inliers
  [out] | fitness_score | current best score

Note
  fitness score is only updated if the score of the current transformation exceeds the input one.

Returns
  - < 0 if previous result is better than the current one (score remains)
  - = 0 current result is better than the previous one (score updated)

Reimplemented from pcl::registration::FPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >.

Definition at line 164 of file ia_kfpcs.hpp.

References M_PI, M_PI_2, pcl::PointCloud< PointT >::size(), and pcl::transformPointCloud().

## Member Data Documentation

## candidates_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

MatchingCandidates pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::candidates_

protected

Container for resulting vector of registration candidates.

Definition at line 258 of file ia_kfpcs.h.

## indices_validation_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

pcl::IndicesPtr pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::indices_validation_

protected

Subset of input indices on which we evaluate candidates.

To speed up the evaluation, we only use a fix number of indices defined during initialization.

Definition at line 268 of file ia_kfpcs.h.

## lambda_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::lambda_ {0.5f}

protected

Weighting factor for translation costs (standard = 0.5).

Definition at line 255 of file ia_kfpcs.h.

Referenced by pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getLambda(), and pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setLambda().

## lower_trl_boundary_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::lower_trl_boundary_ {-1.f}

protected

Lower boundary for translation costs calculation.

Note
  If not set by the user, the translation costs are not used during evaluation.

Definition at line 246 of file ia_kfpcs.h.

Referenced by pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getLowerTranslationThreshold(), and pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setLowerTranslationThreshold().

## upper_trl_boundary_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

float pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::upper_trl_boundary_ {-1.f}

protected

Upper boundary for translation costs calculation.

Note
  If not set by the user, it is calculated from the estimated overlap and the diameter of the point cloud.

Definition at line 252 of file ia_kfpcs.h.

Referenced by pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::getUpperTranslationThreshold(), and pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::setUpperTranslationThreshold().

## use_trl_score_

template<typename PointSource , typename PointTarget , typename NormalT = pcl::Normal, typename Scalar = float>

bool pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::use_trl_score_ {false}

protected

Flag if translation score should be used in validation (internal calculation).

Definition at line 262 of file ia_kfpcs.h.

The documentation for this class was generated from the following files:

- pcl/registration/ia_kfpcs.h
- pcl/registration/impl/ia_kfpcs.hpp